Index: 1.1.6/tools/mkimage.c
===================================================================
--- 1.1.6.orig/tools/mkimage.c	2007-01-25 16:46:41.000000000 +0100
+++ 1.1.6/tools/mkimage.c	2007-01-29 10:53:41.000000000 +0100
@@ -166,6 +166,7 @@ int eflag    = 0;
 int lflag    = 0;
 int vflag    = 0;
 int xflag    = 0;
+int pflag    = 0;
 int opt_os   = IH_OS_LINUX;
 int opt_arch = IH_CPU_PPC;
 int opt_type = IH_TYPE_KERNEL;
@@ -250,6 +251,9 @@ main (int argc, char **argv)
 					usage ();
 				name = *++argv;
 				goto NXTARG;
+			case 'p':
+				pflag = 1;
+				break;
 			case 'v':
 				vflag++;
 				break;
@@ -442,7 +446,7 @@ NXTARG:		;
 			}
 		}
 	} else {
-		copy_file (ifd, datafile, 0);
+		copy_file (ifd, datafile, pflag);
 	}
 
 	/* We're a bit of paranoid */
@@ -598,7 +602,7 @@ usage ()
 {
 	fprintf (stderr, "Usage: %s -l image\n"
 			 "          -l ==> list image header information\n"
-			 "       %s [-x] -A arch -O os -T type -C comp "
+			 "       %s [-x] -A arch -O os -T type [-p] -C comp "
 			 "-a addr -e ep -n name -d data_file[:data_file...] image\n",
 		cmdname, cmdname);
 	fprintf (stderr, "          -A ==> set architecture to 'arch'\n"
@@ -609,6 +613,7 @@ usage ()
 			 "          -e ==> set entry point to 'ep' (hex)\n"
 			 "          -n ==> set image name to 'name'\n"
 			 "          -d ==> use image data from 'datafile'\n"
+                         "          -p ==> alway pad image to word boundary\n"
 			 "          -x ==> set XIP (execute in place)\n"
 		);
 	exit (EXIT_FAILURE);
@@ -749,3 +754,4 @@ static int get_table_entry (table_entry_
 	fprintf (stderr, "\n");
 	return (-1);
 }
+
